#pragma once

#include "CoreMinimal.h"
#include "Perk.h"
#include "Templates/SubclassOf.h"
#include "GameplayTagContainer.h"
#include "TeamworkGeneratorPerk.generated.h"

class UStatusEffect;
class UFloatValueStrategy;
class AGenerator;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class DEADBYDAYLIGHT_API UTeamworkGeneratorPerk : public UPerk
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	bool _deactivateOnMissedNormalSkillCheck;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _survivorRepairerStatusEffectToApplyWhenTeamworkBonusActive;

	UPROPERTY(EditAnywhere)
	FGameplayTag _modifierTypeOfTeamworkBonus;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	TArray<UFloatValueStrategy*> _modifierValueOfTeamworkBonusPerOtherCooperatingRepairers;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AGenerator* _generatorWorkedOnByOwningSurvivor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UFloatValueStrategy* _cooldownDuration;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Replicated, meta=(AllowPrivateAccess=true))
	bool _isTeamworkBonusActive;

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UTeamworkGeneratorPerk();
};

FORCEINLINE uint32 GetTypeHash(const UTeamworkGeneratorPerk) { return 0; }
